unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls,

  BGRABitmapTypes, BGRABitmap, BGRASVG, BGRAUnits;

type

  { TForm1 }

  TForm1 = class(TForm)
    BtnTest2a: TButton;
    BtnTest1: TButton;
    BtnTest2b: TButton;
    Image1: TImage;
    Panel1: TPanel;
    procedure BtnTest1Click(Sender: TObject);
    procedure BtnTest2aClick(Sender: TObject);
    procedure BtnTest2bClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure Test1;
    procedure Test2a;
    procedure Test2b;

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
 kzoom = 10;

procedure TForm1.Test1;
Var
 w,h: Integer;
 bmp: TBGRABitmap;
 svg: TBGRASVG;
begin
 bmp:= TBGRABitmap.Create;
 try
  svg:= TBGRASVG.Create('svg\tag1.svg');
  try
   w:= Round(svg.Width.value*kzoom);
   h:= Round(svg.Height.value*kzoom);
   ShowMessage(IntToStr(w)+'x'+IntToStr(h) );

   w:= 100;
   h:= 100;

   bmp.SetSize(w,h);
   bmp.Fill(BGRAWhite);
   svg.Draw(bmp.Canvas2D, 0,0, cuPixel);
   Image1.Picture.Bitmap.Assign(bmp);
  finally
   svg.Free;
  end;
 finally
  bmp.Free;
 end;
end;

procedure TForm1.Test2a;
Var
 w,h: Integer;
 bmp: TBGRABitmap;
 svg: TBGRASVG;
begin
 bmp:= TBGRABitmap.Create;
 try
  svg:= TBGRASVG.Create('svg\tag2.svg');
  try
   w:= Round(svg.Width.value*kzoom);
   h:= Round(svg.Height.value*kzoom);
   ShowMessage(IntToStr(w)+'x'+IntToStr(h) );

   w:= 300;
   h:= 300;

   bmp.SetSize(w,h);
   bmp.Fill(BGRAWhite);

   svg.StretchDraw(bmp.Canvas2D, 0,0,w,h);

   Image1.Picture.Bitmap.Assign(bmp);
  finally
   svg.Free;
  end;
 finally
  bmp.Free;
 end;
end;

procedure TForm1.Test2b;
Var
 w,h: Integer;
 bmp: TBGRABitmap;
 svg: TBGRASVG;
begin
 //(THIS: WITHOUT EOutOfMemory ERROR)

 bmp:= TBGRABitmap.Create;
 try
  svg:= TBGRASVG.Create('svg\tag2.svg');
  try
   w:= Round(svg.Width.value*kzoom);
   h:= Round(svg.Height.value*kzoom);
   ShowMessage(IntToStr(w)+'x'+IntToStr(h) );

   w:= 300;
   h:= 300;

   bmp.SetSize(w,h);
   bmp.Fill(BGRAWhite);

   svg.Draw(bmp.Canvas2D, 0,0, cuPixel);

   Image1.Picture.Bitmap.Assign(bmp);
  finally
   svg.Free;
  end;
 finally
  bmp.Free;
 end;
end;

procedure TForm1.BtnTest1Click(Sender: TObject);
begin
 Test1;
end;

procedure TForm1.BtnTest2aClick(Sender: TObject);
begin
 Test2a;
end;

procedure TForm1.BtnTest2bClick(Sender: TObject);
begin
 Test2b;
end;

end.

